#######################
# DSF-to-GML v2
#######################

BEGIN { 
	coordinates_3d = 0
	segment_nodes = 0

	###########################
	inpatch_city = 0
	inpatch_apt = 0

	terdef0 = 0
	terdefx = 0
	polydef0 = 0
	polydefx = 0
	objdef0 = 0
	objdefx = 0	
	netdef0 = 0
	netdefx = 0
	
	
	deffound = 0
	terdeffound = 0
	polydeffound = 0
	objdeffound = 0
	networkdeffound = 0
	
	fancenterx = 0
	fancentery = 0
	fancenterz = 0


	outfile_dsf_gml = "temp/dsf.gml"
	outfile_write = ""
	
	num_objects = 0

	current_terdef = 0
	current_flag = ""
}
{ 
	if ( ( $1 == "TERRAIN_DEF" || $1 == "POLYGON_DEF" || $1 == "NETWORK_DEF" || $1 == "OBJECT_DEF"  ) && deffound != 1 ) {
		# calculate bounding box from file name
		deffound = 1
	
		y1 = substr(FILENAME, match(FILENAME,"(\+|\-)[0-9]") , 3) + 0
		x1 = substr(FILENAME, match(FILENAME,"(\+|\-)[0-9]") + 3, 4) + 0
		y2 = y1 + 1
		x2 = x1 + 1

		# Put out header of GML file
		print "<?xml version=\"1.0\" encoding=\"utf-8\" ?>" > outfile_dsf_gml
		print "<ogr:FeatureCollection" > outfile_dsf_gml
		print "     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" > outfile_dsf_gml
		print "     xsi:schemaLocation=\"http://ogr.maptools.org/test1.xsd\"" > outfile_dsf_gml
		print "     xmlns:ogr=\"http://ogr.maptools.org/\"" > outfile_dsf_gml
		print "     xmlns:gml=\"http://www.opengis.net/gml\">" > outfile_dsf_gml
		print "  <gml:boundedBy>" > outfile_dsf_gml
		print "    <gml:Box>" > outfile_dsf_gml
		print "      <gml:coord><gml:X>"x1"</gml:X><gml:Y>"y1"</gml:Y></gml:coord>" > outfile_dsf_gml
		print "      <gml:coord><gml:X>"x2"</gml:X><gml:Y>"y2"</gml:Y></gml:coord>" > outfile_dsf_gml
		print "    </gml:Box>" > outfile_dsf_gml
		print "  </gml:boundedBy>" > outfile_dsf_gml
	}
	
######## DEFINITION ARRAYS #####################
	if ( $1 == "TERRAIN_DEF" && terdeffound != 1 ) {
		# find the first row, where a TERRAIN_DEF is
		terdef0 = NR
		terdeffound = 1
		print "First terdef at:"terdef0
	}
	if ( $1 == "POLYGON_DEF" && polydeffound != 1 ) {
		# find the first row, where a POLYGON_DEF is
		polydef0 = NR
		polydeffound = 1
		print "First polydef at:"polydef0
	}	
	if ( $1 == "OBJECT_DEF" && objdeffound != 1 ) {
		# find the first row, where a POLYGON_DEF is
		objdef0 = NR
		objdeffound = 1
		print "First objdef at:"objdef0
	}		
	if ( $1 == "NETWORK_DEF" && networkdeffound != 1 ) {
		# find the first row, where a NETWORK_DEF is
		netdef0 = NR
		networkdeffound = 1
		print "First networkdef at:"netdef0
	}
	
	
	if ( $1 == "TERRAIN_DEF" && $2 ~ /terrain\_Water/ ) {
		# getting the water terrain def
		terdefx = NR
		terdefnr = terdefx - terdef0

		terdefnames[terdefnr]= "water"

		if (matchingterdefs_dsf == "") 
			matchingterdefs_dsf = terdefnr
		else
			matchingterdefs_dsf = matchingterdefs_dsf "|" terdefnr
		print terdefx "---" terdefnr "---" terdefnames[terdefnr] "---" matchingterdefs_dsf 
	}
	if ( $1 == "TERRAIN_DEF" && $2 ~ /lib\/g10\/terrain10\// ) {
		# putting together a list of all TERRAIN_DEF numbers for airports, that are for apt
		terdefx = NR
		terdefnr = terdefx - terdef0
		split($2, name_parts, "[.\/]")

		terdefnames[terdefnr]= name_parts[4]

		if (matchingterdefs_dsf == "") 
			matchingterdefs_dsf = terdefnr
		else
			matchingterdefs_dsf = matchingterdefs_dsf "|" terdefnr
		print terdefx "---" terdefnr "---" terdefnames[terdefnr] "---" matchingterdefs_dsf 
	}
	if ( $1 == "TERRAIN_DEF" && $2 ~ /terrain\// ) {
		# putting together a list of all TERRAIN_DEF numbers for airports, that are for apt
		terdefx = NR
		terdefnr = terdefx - terdef0
		split($2, name_parts, "[.\/]")

		terdefnames[terdefnr]= name_parts[2]

		if (matchingterdefs_dsf == "") 
			matchingterdefs_dsf = terdefnr
		else
			matchingterdefs_dsf = matchingterdefs_dsf "|" terdefnr
		print terdefx "---" terdefnr "---" terdefnames[terdefnr] "---" matchingterdefs_dsf 
	}	
	
	if ( $1 == "POLYGON_DEF" ) {
		# putting together a list of all TERRAIN_DEF numbers for airports, that are for apt
		polydefx = NR
		polydefnr = polydefx - polydef0
				
		pos = match($2, "[^\/]*[.][:alpha:]*")
		polydefname = substr($2,pos, length($2) - pos + 1 )
		
		polydefnames[polydefnr]= polydefname

		if (matchingpolydefs_dsf == "") 
			matchingpolydefs_dsf = polydefnr
		else
			matchingpolydefs_dsf = matchingpolydefs_dsf "|" polydefnr
		print terdefx "---" polydefnr "---" polydefnames[polydefnr] "---" matchingpolydefs_dsf 
	}	

	if ( $1 == "OBJECT_DEF" ) {
		# putting together a list of all TERRAIN_DEF numbers for airports, that are for apt
		objdefx = NR
		objdefnr = objdefx - objdef0
				
		pos = match($2, "[^\/]*[.][:alpha:]*")
		objdefname = substr($2,pos, length($2) - pos + 1 )

		objdefnames[objdefnr]= objdefname

		if (matchingobjdefs_dsf == "") 
			matchingobjdefs_dsf = objdefnr
		else
			matchingobjdefs_dsf = matchingobjdefs_dsf "|" objdefnr
		print terdefx "---" objdefnr "---" objdefnames[objdefnr] "---" matchingobjdefs_dsf 
	}	
	
######## TERRAIN PROCESSING #####################
	if ( $1 == "BEGIN_PATCH" ) {
		inpatch = 0
		outfile_write = ""
	}
	# String $5 holds the status flag of the patch, which tells wether it consists of overlay or physical triangles
	#if ( $1 == "BEGIN_PATCH" && $2 ~ matchingterdefs_dsf && $5 == 1 && matchingterdefs_dsf != "") {
	if ( $1 == "BEGIN_PATCH" && $2 ~ matchingterdefs_dsf && matchingterdefs_dsf != "") {
		inpatch = 1
		current_terdef = $2
		current_flag = ""
		if( $5 == 1 ) {current_flag = "physical"}
		if( $5 == 2 ) {current_flag = "overlay"}

		outfile_write = outfile_dsf_gml
		print NR "<apt> BEGIN_PATCH " current_terdef
	} 

	if ( inpatch == 1 && $1 == "BEGIN_PRIMITIVE" && $2 == 0 ) {
		primitivetype=0
		tri_vertex=0
		print ">     BEGIN_PRIMITIVE " primitivetype
	}
	if ( inpatch == 1 && $1 == "BEGIN_PRIMITIVE" && $2 == 1 ) {
		primitivetype=1
		tri_vertex=0
		print ">     BEGIN_PRIMITIVE " primitivetype
	}
	if ( inpatch == 1 && $1 == "BEGIN_PRIMITIVE" && $2 == 2 ) {
		primitivetype=2
		tri_vertex=0
		print ">     BEGIN_PRIMITIVE " primitivetype
	}

	if ( inpatch == 1 && primitivetype == 0 && $1 == "PATCH_VERTEX" ) {
		tri_vertex++
		if ( tri_vertex == 1 ) {
			firstpointx=$2
			firstpointy=$3
			firstpointz=$4 
			
  			print "   <gml:featureMember>" > outfile_write
			print "      <ogr:terrains fid=\"F0\">" > outfile_write
 			print "         <ogr:TERRAIN>"terdefnames[current_terdef]"</ogr:TERRAIN>" > outfile_write
 			print "         <ogr:FLAG>"current_flag"</ogr:FLAG>" > outfile_write
			print "         <ogr:geometryProperty><gml:Polygon><gml:outerBoundaryIs><gml:LinearRing><gml:coordinates>" > outfile_write
		}
			if ( coordinates_3d == 1)
			    print "         "$2","$3","$4 > outfile_write
			else
			    print "         "$2","$3 > outfile_write
		if ( tri_vertex == 3 ) {
			if ( coordinates_3d == 1)
			    print "         "firstpointx","firstpointy","firstpointz > outfile_write
			else
			    print "         "firstpointx","firstpointy > outfile_write    
			    
			print "         </gml:coordinates></gml:LinearRing></gml:outerBoundaryIs></gml:Polygon></ogr:geometryProperty>" > outfile_write	
			print "      </ogr:terrains>" > outfile_write
  			print "   </gml:featureMember>" > outfile_write
			tri_vertex=0
		}
	}

	if ( inpatch == 1 && primitivetype == 1 && $1 == "PATCH_VERTEX" ) {
		tri_vertex++

		if ( tri_vertex == 1 ) {
			stripfirstx = $2
			stripfirsty = $3	
			stripfirstz = $4
		}
		if ( tri_vertex == 2 ) {
			stripsecondx = $2
			stripsecondy = $3
			stripsecondz = $4
		}

		if ( tri_vertex == 3 ) {
  			print "   <gml:featureMember>" > outfile_write
			print "      <ogr:terrains fid=\"F0\">" > outfile_write
 			print "         <ogr:TERRAIN>"terdefnames[current_terdef]"</ogr:TERRAIN>" > outfile_write
 			print "         <ogr:FLAG>"current_flag"</ogr:FLAG>" > outfile_write
			print "         <ogr:geometryProperty><gml:Polygon><gml:outerBoundaryIs><gml:LinearRing><gml:coordinates>" > outfile_write	
			if ( coordinates_3d == 1) {
			    print "         "stripfirstx","stripfirsty","stripfirstz > outfile_write
			    print "         "stripsecondx","stripsecondy","stripsecondz > outfile_write
			    print "         "$2","$3","$4 > outfile_write
			    print "         "stripfirstx","stripfirsty","stripfirstz > outfile_write
			} else {
			    print "         "stripfirstx","stripfirsty > outfile_write
			    print "         "stripsecondx","stripsecondy > outfile_write
			    print "         "$2","$3 > outfile_write
			    print "         "stripfirstx","stripfirsty > outfile_write
			}
			print "         </gml:coordinates></gml:LinearRing></gml:outerBoundaryIs></gml:Polygon></ogr:geometryProperty>" > outfile_write	
			print "      </ogr:terrains>" > outfile_write
  			print "   </gml:featureMember>" > outfile_write
			stripfirstx = stripsecondx
			stripfirsty = stripsecondy
			stripfirstz = stripsecondz
			stripsecondx = $2
			stripsecondy = $3
			stripsecondz = $4
			tri_vertex=2
		}
	}

	if ( inpatch == 1 && primitivetype == 2 && $1 == "PATCH_VERTEX" ) {
		tri_vertex++

		if ( tri_vertex == 1 ) {
  			print "   <gml:featureMember>" > outfile_write
			print "      <ogr:terrains fid=\"F0\">" > outfile_write
 			print "         <ogr:TERRAIN>"terdefnames[current_terdef]"</ogr:TERRAIN>" > outfile_write
 			print "         <ogr:FLAG>"current_flag"</ogr:FLAG>" > outfile_write
			print "         <ogr:geometryProperty><gml:Polygon><gml:outerBoundaryIs><gml:LinearRing><gml:coordinates>" > outfile_write	

			fancenterx = $2
			fancentery = $3	
			fancenterz = $4	
		}
		if ( coordinates_3d == 1) 
		    print "         "$2","$3","$4 > outfile_write
		else
		    print "         "$2","$3 > outfile_write
	}


	if ( inpatch == 1 && $1 ~ /END_PRIMITIVE/ ) {
		if ( inpatch == 1 && primitivetype == 2 ) {
			if ( coordinates_3d == 1) 
			    print "         "fancenterx","fancentery","fancenterz > outfile_write
			else
			    print "         "fancenterx","fancentery > outfile_write
			print "         </gml:coordinates></gml:LinearRing></gml:outerBoundaryIs></gml:Polygon></ogr:geometryProperty>" > outfile_write	
			print "      </ogr:terrains>" > outfile_write
  			print "   </gml:featureMember>" > outfile_write
		}
		print ">     END_PRIMITIVE"
	}	
	if ( inpatch == 1 && $1 ~ /END_PATCH/ ) {
		inpatch = 0
		print NR "> END_PATCH"
	}
######## POLYGON PROCESSING #####################
	if ( $1 == "BEGIN_POLYGON" ) {
		inpoly = 0
		outfile_write = ""
	}
	# String $4 holds the number of coordinates ... 2d or 3d
	if ( $1 == "BEGIN_POLYGON" && $2 ~ matchingpolydefs_dsf && matchingpolydefs_dsf != "") {
		inpoly = 1
		current_coords = 2
		
		current_polydef = $2
		current_flag = $3
		current_coords = $4
		
		first_winding=1
		
		open_polygon=0
		is_ring = 0

		outfile_write = outfile_dsf_gml
		
		polydefname=polydefnames[current_polydef]
		
		featuretype ="polygon_other"
				
		if ( match(polydefname,"[.]bch") > 0 ) {
		    featuretype = "polygon_beach"	
		    open_polygon=1
		     if (current_flag == 1) is_ring=1
		}
		if ( match(polydefname,"[.]lin") > 0 ) {
		    featuretype = "polygon_line"	
		    open_polygon=1
		     if (current_flag == 1) is_ring=1
		}		
		if ( match(polydefname,"[.]str") > 0 ) {
		    featuretype = "polygon_string"	
		    open_polygon=1
		}			
		if ( match(polydefname,"[.]pol") > 0 ) 
		    featuretype = "polygon_pol"     
		if ( match(polydefname,"[.]for") > 0 ) {
		    featuretype = "polygon_forests"
		    if (current_flag >= 256) open_polygon=1
		}
		if ( match(polydefname,"[.]agp") > 0 )
		    featuretype = "polygon_autgen_points"		    
		if ( match(polydefname,"[.]agb") > 0 )
		    featuretype = "polygon_autgen_blocks"
		if ( match(polydefname,"[.]ags") > 0 )
		    featuretype = "polygon_autogen_strings"		    
		if ( match(polydefname,"[.]fac") > 0 )
		    featuretype = "polygon_facades"				    
				
		print "   <gml:featureMember>" > outfile_write
		print "      <ogr:" featuretype " fid=\"F0\">" > outfile_write
		print "         <ogr:TYPE>"polydefname"</ogr:TYPE>" > outfile_write
		print "         <ogr:FLAG>"current_flag"</ogr:FLAG>" > outfile_write
		if ( open_polygon == 1 )
		    print "         <ogr:geometryProperty><gml:LineString>" > outfile_write	
		else
		    print "         <ogr:geometryProperty><gml:Polygon>" > outfile_write	
		      
		print NR "<apt> BEGIN_POLYGON " current_polydef
	} 
	
	if ( inpoly == 1 && $1 == "BEGIN_WINDING") {
		poly_vertex=0
		print ">     BEGIN_WINDING"
	
		if ( open_polygon == 0 ){
		    if ( first_winding == 1 ) 
			print "               <gml:outerBoundaryIs><gml:LinearRing><gml:coordinates>" > outfile_write	
		    else
			print "               <gml:innerBoundaryIs><gml:LinearRing><gml:coordinates>" > outfile_write	
		} else {
		    print "               <gml:coordinates>" > outfile_write
		}
	}	
	
	if ( inpoly == 1 && $1 == "POLYGON_POINT" ) {
		poly_vertex++
		if ( poly_vertex == 1 ) {
			firstpointx=$2
			firstpointy=$3
			firstpointz=$4 
		}

		if ( coordinates_3d == 1 && current_coords == 3 ) 
		    print "         "$2","$3","$4 > outfile_write
		else
		    print "         "$2","$3 > outfile_write
	}
	
	if ( inpoly == 1 && $1 == "END_WINDING") {
		
		print ">     END_WINDING"
		
		if ( open_polygon == 0 ){

		    if ( coordinates_3d == 1 && current_coords == 3 ) 
			print "         "firstpointx","firstpointy","firstpointz > outfile_write
		    else
			print "         "firstpointx","firstpointy > outfile_write	
			
		    if ( first_winding == 1 ) 
			print "               </gml:coordinates></gml:LinearRing></gml:outerBoundaryIs>" > outfile_write	
		    else
			print "               </gml:coordinates></gml:LinearRing></gml:innerBoundaryIs>" > outfile_write	
		} else {
		    if ( is_ring == 1 ) { 
			if ( coordinates_3d == 1 && current_coords == 3 )
			    print "         "firstpointx","firstpointy","firstpointz > outfile_write
			else
			    print "         "firstpointx","firstpointy > outfile_write		      
		    }
		    print "               </gml:coordinates>" > outfile_write
		}
		poly_vertex=0
		first_winding = 0
	}	
		
	if ( inpoly == 1 && $1 ~ /END_POLYGON/ ) {		    

		if ( open_polygon == 1 )
		    print "         </gml:LineString></ogr:geometryProperty>" > outfile_write	
		else
		    print "         </gml:Polygon></ogr:geometryProperty>" > outfile_write		
		
		print "      </ogr:"featuretype">" > outfile_write
		print "   </gml:featureMember>" > outfile_write
	      
		inpoly = 0		
		print NR "> END_POLYGON"
	}	
	
######## SEGMET PROCESSING #####################

	# String $4 holds the number of coordinates ... 2d or 3d
	if ( $1 == "BEGIN_SEGMENT" ) {
		inseg = 1
		outfile_write = ""		
		
		current_type = $2
		current_subtype = $3
		current_nodeid = $4
		
		firstpointx=$5
		firstpointy=$6
		firstpointelev=$7 		
				
		outfile_write = outfile_dsf_gml		
		
		if (segment_nodes == 1) {
		    print "   <gml:featureMember>" > outfile_write
		    print "      <ogr:network_nodes fid=\"F0\">" > outfile_write
		    print "         <ogr:NODEID>"current_nodeid"</ogr:NODEID>" > outfile_write
		    print "         <ogr:geometryProperty><gml:Point>" > outfile_write	
		    if ( coordinates_3d == 1) 
			print "               <gml:coordinates>"firstpointx","firstpointy","firstpointelev"</gml:coordinates>" > outfile_write	
		    else
			print "               <gml:coordinates>"firstpointx","firstpointy"</gml:coordinates>" > outfile_write
		    print "         </gml:Point></ogr:geometryProperty>" > outfile_write	
		    print "      </ogr:network_nodes>" > outfile_write
		    print "   </gml:featureMember>" > outfile_write		
		}
		
		print "   <gml:featureMember>" > outfile_write
		print "      <ogr:network_segments fid=\"F0\">" > outfile_write
		print "         <ogr:SUBTYPE>"current_subtype"</ogr:SUBTYPE>" > outfile_write
		print "         <ogr:geometryProperty><gml:LineString>" > outfile_write	
		print "               <gml:coordinates>" > outfile_write	
		if ( coordinates_3d == 1) 
		     print "               "firstpointx","firstpointy","firstpointelev > outfile_write
		else
		     print "               "firstpointx","firstpointy > outfile_write
		      
		      
		print NR "<apt> BEGIN_SEGMENT " current_subtype		
	}

	if ( inseg == 1 && $1 == "SHAPE_POINT" ) {
		if ( coordinates_3d == 1 ) 
		    print "               "$2","$3","$4 > outfile_write
		else
		    print "               "$2","$3 > outfile_write
	}	
	
	if ( inseg == 1 && $1 == "END_SEGMENT" ) {		    
		current_nodeid = $2
		
		lastpointx=$3
		lastpointy=$4
		lastpointelev=$5
		
		if ( coordinates_3d == 1) 
		     print "               "lastpointx","lastpointy","lastpointelev > outfile_write
		else
		     print "               "lastpointx","lastpointy > outfile_write
		print "               </gml:coordinates>" > outfile_write			
		print "         </gml:LineString></ogr:geometryProperty>" > outfile_write	
		print "      </ogr:network_segments>" > outfile_write
		print "   </gml:featureMember>" > outfile_write

		if (segment_nodes == 1) {
		    print "   <gml:featureMember>" > outfile_write
		    print "      <ogr:network_nodes fid=\"F0\">" > outfile_write
		    print "         <ogr:NODEID>"current_nodeid"</ogr:NODEID>" > outfile_write
		    print "         <ogr:geometryProperty><gml:Point>" > outfile_write	
		    if ( coordinates_3d == 1) 
			print "               <gml:coordinates>"lastpointx","lastpointy","lastpointelev"</gml:coordinates>" > outfile_write	
		    else
			print "               <gml:coordinates>"lastpointx","lastpointy"</gml:coordinates>" > outfile_write
		    print "         </gml:Point></ogr:geometryProperty>" > outfile_write	
		    print "      </ogr:network_nodes>" > outfile_write
		    print "   </gml:featureMember>" > outfile_write
		}
		
		inseg = 0		
		print NR "> END_SEGMENT"
	}		
######## OBJECT PROCESSING #####################	
	if ( $1 == "OBJECT" && $2 ~ matchingobjdefs_dsf && matchingobjdefs_dsf != "") {
		current_objdef = $2
		current_objx = $3
		current_objy = $4
		current_objori = $5
		current_objelev = $6

		
		objdefname=objdefnames[current_objdef]
		
		outfile_write = outfile_dsf_gml
		print NR "OBJECT " current_objdef
		

		print "   <gml:featureMember>" > outfile_write
		print "      <ogr:objects fid=\"F0\">" > outfile_write
		print "         <ogr:TYPE>"objdefname"</ogr:TYPE>" > outfile_write		
		print "         <ogr:ORIENTATION>"current_objori"</ogr:ORIENTATION>" > outfile_write
		print "         <ogr:geometryProperty><gml:Point>" > outfile_write	
		if ( coordinates_3d == 1 && length(current_objelev) > 0 ) 
		    print "               <gml:coordinates>"current_objx","current_objy","current_objelev"</gml:coordinates>" > outfile_write	
		else
		    print "               <gml:coordinates>"current_objx","current_objy"</gml:coordinates>" > outfile_write
		print "         </gml:Point></ogr:geometryProperty>" > outfile_write	
		print "      </ogr:objects>" > outfile_write
		print "   </gml:featureMember>" > outfile_write	
	} 					
} 
END {
	print "  </ogr:FeatureCollection>" > outfile_dsf_gml
}